/*******************************************************************************
  MPLAB Harmony Graphics Object Library Asset Source File

  File Name:
    gfx_assets.c

  Summary:
    Source file containing asset data for use with the MPLAB Harmony Graphics
	Object Library.

  Description:
    Source file containing asset data for use with the MPLAB Harmony Graphics
	Object Library.

    Created with MPLAB Harmony Version 2.05
*******************************************************************************/
// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*******************************************************************************/
// DOM-IGNORE-END

#include "gfx/gfx_assets.h"

/*****************************************************************************
 Asset Manifest
 -------------------
 
 Fonts
 -------
    TimesNewRoman


 String Table
 -------
    stringTable
 
 *****************************************************************************/

/*****************************************************************************
 * SECTION:  Fonts
 
 - font lookup table data description -
1 byte - size of the address offset values in this table, 1-4 possible
1 byte - size of the address width values in this table, 1-2 possible
  for each glyph entry in lookup table:
    1-4 bytes - glyph data offset in bytes
    1-2 bytes - glyph raster width in pixels	
 
 *****************************************************************************/
uint8_t TimesNewRoman_lookup_50[4] =
{
    0x01,0x01,0x00,0x0B,
};

uint8_t TimesNewRoman_lookup_68[4] =
{
    0x01,0x01,0x30,0x09,
};

uint8_t TimesNewRoman_lookup_73[4] =
{
    0x01,0x01,0x60,0x08,
};

uint8_t TimesNewRoman_lookup_75[4] =
{
    0x01,0x01,0x78,0x09,
};


GFXU_FontGlyphIndexTable TimesNewRoman_index_table =
{
	4, // range count
    {
	    /* 0x50 */
        {
		    1, // glyph count
		    0x50, // starting glyph id
		    0x50, // ending glyph id
		    TimesNewRoman_lookup_50 // glyph lookup table
        },
	    /* 0x68 */
        {
		    1, // glyph count
		    0x68, // starting glyph id
		    0x68, // ending glyph id
		    TimesNewRoman_lookup_68 // glyph lookup table
        },
	    /* 0x73 */
        {
		    1, // glyph count
		    0x73, // starting glyph id
		    0x73, // ending glyph id
		    TimesNewRoman_lookup_73 // glyph lookup table
        },
	    /* 0x75 */
        {
		    1, // glyph count
		    0x75, // starting glyph id
		    0x75, // ending glyph id
		    TimesNewRoman_lookup_75 // glyph lookup table
        },
    }
};
		
// 4 glyphs @ 1 bpp
const uint8_t TimesNewRoman_data[168] =
{
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,
    0x00,0x31,0x80,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x31,0x80,0x3F,0x00,
    0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x60,0x00,0xE0,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x63,
    0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0xF7,0x80,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x3A,0x46,0x42,0x70,0x3C,0x0E,0x42,0x62,0x5C,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xE7,0x00,0x63,0x00,0x63,0x00,0x63,0x00,
    0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x80,0x3B,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,
};

GFXU_FontAsset TimesNewRoman =
{
	{
        GFXU_ASSET_TYPE_FONT, // asset type
	    GFXU_ASSET_LOCATION_ID_INTERNAL, // data location id
	    (void*)TimesNewRoman_data, // data address pointer
	    168, // data size
    },	
	24, // font height
	19, // font max ascent
	4, // font max descent
	5, // font baseline
	GFXU_FONT_BPP_1, // bits per pixel
	&TimesNewRoman_index_table // glyph index table
};
		


/*****************************************************************************
 * SECTION:  Strings
 
 - String table data format description -

 2 bytes - number of unique string values
 
 for each string value:
   2 bytes - size of the string in bytes
   n bytes - character code point data, 1-4 bytes each character per encoding	 
 *****************************************************************************/
// 1 language, 1 unique string value, ASCII encoding
uint8_t stringTable_data[8] =
{
    0x01,0x00,0x04,0x00,0x50,0x75,0x73,0x68,
};
	
/*****************************************************************************
  - String index table data format description -

 2 bytes - number of strings in the string table
 1 byte - number of languages in the string table
 1 byte - size of the string indicies, equals 2 if there are more than 254
          strings
		  
 for each string in table:
    for each language in table:
	    1-2 bytes - string data table entry	 
 *****************************************************************************/
// Lookup table for associating string and language IDs to string data.
uint8_t stringIndexTable_data[5] =
{
    0x01,0x00,0x01,0x01,0x00,
};
	
GFXU_FontAsset* fontList[1] =
{
	&TimesNewRoman,
};

/*****************************************************************************
  - Font index table data format description -

 2 bytes - number of strings in the string table
 1 byte - number of languages in the string table
		  
 for each string in table:
    for each language in table:
	    1 byte - the font to use for the string	 
		
 id = 0xFF if no font association
 *****************************************************************************/
// Lookup table for associating strings, languages, and fonts
uint8_t fontIndexTable_data[4] =
{
    0x01,0x00,0x01,0x00,
};
	
GFXU_StringTableAsset stringTable =
{
	{
        GFXU_ASSET_TYPE_STRINGTABLE, // asset type
	    GFXU_ASSET_LOCATION_ID_INTERNAL, // data location id
	    (void*)stringTable_data, // data address pointer
	    8, // data size
    },	
	1, // language count
	1, // string count
    stringIndexTable_data, // font lookup table
    fontList, // font lookup table
    fontIndexTable_data, // font index table
	GFXU_STRING_ENCODING_ASCII // encoding standard
};
		

